<?php

/****************************************************************************
"JpegExifReader" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
class JpegExifReader
{
// member variable
public		$m_Exif;

// public functions
//=======================================================================
//!	construct
//-----------------------------------------------------------------------
function __construct()
{
	$this->m_Exif = array();
}
//=======================================================================
//!	ファイルの読み込み
//!	@retval			---
//-----------------------------------------------------------------------
public function Load
		(
		$filepath
		)
{
	if( file_exists( $filepath ) == FALSE )
		return true;
	if( IMAGETYPE_JPEG != exif_imagetype( $filepath ) )	
		return false;

	// exif
	if( true == ( $exif = exif_read_data( $filepath ,'EXIF') ) )
	{
		foreach( $exif as $key=>$sect )
		{
			if( is_array( $sect ) == false )
			{
				$this->m_Exif[ $key ]	= $sect;
			}
			else
			{
				foreach( $sect as $name=>$val )
				{
					$this->m_Exif[ $key . $name ] = $val;
				}
			}
		}
	}
	return true;
}
//=======================================================================
//!	get DateTimeOriginal
//!	@retval			---
//-----------------------------------------------------------------------
public function GetDateTimeOriginal()
{
	return $this->m_Exif[ "DateTimeOriginal" ];
}
//=======================================================================
//!	GetGPSLatitude
//!	@retval			---
//-----------------------------------------------------------------------
public function GetGPSLatitude
		(
		&$latitude_ref , 
		&$latitude0 , 
		&$latitude1 , 
		&$latitude2
		)
{
	if( $this->m_Exif[ "GPSLatitudeRef" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLatitude0" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLatitude1" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLatitude2" ] == false )
		return false;
	$latitude_ref 	= $this->m_Exif[ "GPSLatitudeRef" ];
	$latitude0 		= $this->m_Exif[ "GPSLatitude0" ];
	$latitude1 		= $this->m_Exif[ "GPSLatitude1" ];
	$latitude2 		= $this->m_Exif[ "GPSLatitude2" ];
	return true;
}
//=======================================================================
//!	GetGPSLongitude
//!	@retval			---
//-----------------------------------------------------------------------
public function GetGPSLongitude
		(
		&$longitude_ref , 
		&$longitude0 , 
		&$longitude1 , 
		&$longitude2
		)
{
	if( $this->m_Exif[ "GPSLongitudeRef" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLongitude0" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLongitude1" ] == false )
		return false;
	if( $this->m_Exif[ "GPSLongitude2" ] == false )
		return false;
	$longitude_ref 	= $this->m_Exif[ "GPSLongitudeRef" ];
	$longitude0 	= $this->m_Exif[ "GPSLongitude0" ];
	$longitude1 	= $this->m_Exif[ "GPSLongitude1" ];
	$longitude2 	= $this->m_Exif[ "GPSLongitude2" ];
	return true;
}

};


?>