<?php
//=======================================================================
//!	日付に基づいたファイル名の生成
//!	@retval			---
//-----------------------------------------------------------------------
function GenerateFilename
		(
		$directory , 
		$ext
		)
{
	while( true )
	{
		$name = date( "YmdHis" ) . "_" . rand( 0 , 1000000 );
		if( file_exists( $directory . "/" . $name . "." . $ext ) == false )
			return $name;
	}
}
//=======================================================================
//!	すべてのディレクトリの生成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateFolderFull
		(
		$directory
		)
{
	$list = split( "/" , $directory );
	
	$s_dir = "";
	foreach( $list as $entry )
	{
		$s_dir .= $entry;
		$s_dir .= "/";
		@mkdir( $s_dir );
	}
}
//=======================================================================
//!	JPEGのサムネイルの作成
//!	@retval			---
//-----------------------------------------------------------------------
function GenerateJPEGThumbnail
		(
		$src_path , 
		$tgt_path , 
		$thumb_w , 
		$thumb_h
		)
{
 	$src_img = @imagecreatefromjpeg( $src_path );
	if( $src_img == false )
		return false;
	list( $src_w, $src_h ) = getimagesize( $src_path );

	//ターゲットの幅と高さを求める	
	$tgt_w 	= 0;
	$tgt_h	= 0;
	if( $thumb_w * $src_h >= $thumb_h * $src_w )
	{
		if( $thumb_h < $src_h )
		{
			$tgt_w 	= floor( $src_w * $thumb_h / $src_h );
			$tgt_h	= $thumb_h;
		}
		else
		{
			$tgt_w	= $src_w;
			$tgt_h	= $src_h;
		}
	}
	else
	{
		if( $thumb_w < $src_w )
		{
			$tgt_w	= $thumb_w;
			$tgt_h	= floor( $src_h * $thumb_w / $src_w );
		}
		else
		{
			$tgt_w	= $src_w;
			$tgt_h	= $src_h;
		}
	}

	//ターゲットの作成
	$tgt_img = imagecreatetruecolor ( $tgt_w, $tgt_h );		

	//ターゲットに書き込む
    $result = imagecopyresampled
			(
            $tgt_img ,
            $src_img ,
            0,
            0,
            0,
            0,
            $tgt_w,
            $tgt_h,
            $src_w,
            $src_h
        	);
    //サムネイルをJPEG形式で保存
    imagejpeg( $tgt_img, $tgt_path );
    imagedestroy ( $tgt_img );
    imagedestroy ( $src_img );
	
	return true;
}
//=======================================================================
//!	ファイル名の獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetFilename
		(
		$path
		)
{
	return basename ( $path );
}
//=======================================================================
//!	ディレクトリの獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetDirectory
		(
		$path
		)
{
	$filename	= GetFilename( $path );
	return substr( $path , 0 , strlen( $path ) - strlen( $filename ) );
}

?>