<?php

require_once( './ClassPHP/Misc.class.php' );
require_once( './ClassPHP/JpegExif.class.php' );
require_once( './LocalPHP/LivePhotoAlbumDB.class.php' );
require_once( './Smarty/Smarty.class.php' );
require_once( './LocalPHP/Setting.class.php' );


/****************************************************************************
"PhotoData" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
class PhotoData
{
	public 		$ID;
	public 		$ImagePath;
	public 		$Thumb0Path;
	public 		$Thumb1Path;
	public		$Date;
	public		$Year;
	public		$Month;
	public		$Time;
	public 		$Title;
	public		$Comment;
	public 		$CommentDisp;
	public		$n;
	public		$e;
	public		$Location;
};
/****************************************************************************
"YearCount" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
class YearCount
{
	public 		$Count;
	public 		$MonthCountList;
	function __construct()
	{
		$this->Count = 0;
		$this->MonthCountList = array();
	}

};

/****************************************************************************
"WebPhoto" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
class WebPhoto
{
	// member variable
	private		$m_ImgFolder;
	private		$m_Thumb0_Folder;
	private		$m_Thumb1_Folder;
	private		$m_DB_Path;
	private		$m_Upload_Name;
	
	private		$m_DB;

// private functions
//=======================================================================
//!	year countの獲得
//!	@retval			---
//-----------------------------------------------------------------------
private function GetYearCount()
{
	$this->m_DB->Open();
	$yearcount = array();
	$datelist = $this->m_DB->GetDatelist();
	
	//順位を変換する
	$datelist = array_reverse( $datelist , true );
	foreach ( $datelist as $entry ) 
	{
		$year	= substr( $entry[ "date" ] , 0 , 4 );
		$month 	= substr( $entry[ "date" ] , 4 , 2 );
		if( $yearcount[ $year ] == false )
			$yearcount[ $year ] = new YearCount();
		$yearcount[ $year ]->Count++;
		if( $yearcount[ $year ]->MonthCountList[ "" . $month ] == false )
			$yearcount[ $year ]->MonthCountList[ "" . $month ] = 0;
		$yearcount[ $year ]->MonthCountList[ "" . $month ]++;
	}
	
	return $yearcount;//array_reverse( $yearcount , true );
}
//=======================================================================
//!	get PhotData
//!	@retval			---
//-----------------------------------------------------------------------
private function GetPhotoData
		(
		$id
		)
{
	$this->m_DB->Open();
	$datelist = $this->m_DB->GetData( $id );
	$this->m_DB->Close();
	if( $datelist == false )
		return;

	$data	= new PhotoData();
	$data->ID			= $id;
	$data->ImagePath	= $this->m_ImgFolder . "/" . $id . ".jpg";
	$data->Thumb0Path	= $this->m_Thumb0_Folder . "/" . $id . ".jpg";
	$data->Thumb1Path	= $this->m_Thumb1_Folder . "/" . $id . ".jpg";
	$data->Date			= substr( $datelist[ 0 ][ "date" ] , 4 , 2 ) . "/" . substr( $datelist[ 0 ][ "date" ] , 6 , 2 );
	$data->Time			= substr( $datelist[ 0 ][ "date" ] , 8 , 2 ) . ":" . substr( $datelist[ 0 ][ "date" ] , 10 , 2 ) . ":" . substr( $datelist[ 0 ][ "date" ] , 12 , 2 );
	$data->Title		= $datelist[ 0 ][ "title" ];
	$data->Comment		= $datelist[ 0 ][ "comment" ];
	$data->CommentDisp	= str_replace( "\r\n" , "<br>" , $datelist[ 0 ][ "comment" ] );
	$data->Location		= $datelist[ 0 ][ "location" ];
	$this->LocationToArray( $datelist[ 0 ][ "location" ] , $data->n , $data->e );

	return $data;
}
//=======================================================================
//!	get photodata list
//!	@retval			---
//-----------------------------------------------------------------------
private function GetPhotoDataList
		(
		$start_date , 
		$end_date , 
		$page , 
		$w_num , 
		$h_num , 
		&$pagelist
		)
{
	$this->m_DB->Open();

	$idlist = $this->m_DB->GetIDList( $start_date , $end_date );
	$idlist = array_reverse( $idlist , false );

	$num	= count( $idlist );
	$count	= $page * $w_num * $h_num;

	$datalist = array();
	for( $h = 0 ; $h < $h_num ; $h++ )
	{
		if( $count >= $num )
			break;
		$datalist[ $h ] = array();
		for( $w = 0 ; $w < $w_num ; $w++ )
		{
			$datalist[ $h ][ $w ] = $this->GetPhotoData( $idlist[ $count ][ "id" ] );
			$count++;
			if( $count >= $num )
				break;
		}
	}
	$this->m_DB->Close();
	
	// ページリストの作成
	$pagelist	= array();
	$pagenum	= ceil( $num / ( $w_num * $h_num ) );
	for( $off = 0 ; $off < $pagenum ; $off++ )
	{
		$pagelist[ "" . ( $off ) ] = $off;
	}
	
	return $datalist;
}
//=======================================================================
//!	PhotoView
//!	@retval			---
//-----------------------------------------------------------------------
private function GetPhotoView
		(
		$year , 
		$month , 
		$dispmode , 
		$page ,
		$w_num , 
		$h_num
		)
{
	if( $page == false )
		$page	= 0;
	$pagelist;
	$datalist = $this->GetPhotoDataList
			( 
			$year . ( $month == false ? "00" : $month ) . "00000000" , 
			$year . ( $month == false ? "99" : $month ) . "99999999" , 
			$page , 
			$w_num , 
			$h_num , 
			$pagelist
			);
	$smarty = new Smarty();
	$smarty->assign( "year" , $year );
	$smarty->assign( "pagenum" , count( $pagelist ) );
	$smarty->assign( "month" , $month );	
	$smarty->assign( "dispmode" , $dispmode );
	$smarty->assign( "page" , $page );
	$smarty->assign( "photodatalist" , $datalist );
	$smarty->assign( "pagelist" , $pagelist );

	//photo_viewの設定
	$photo_view;
	if( $dispmode == "index" )
		return $smarty->fetch("../templates/IndexPhotoView.htm");	
	else if( $dispmode == "thumbnail" ) 
		return $smarty->fetch("../templates/ThumbnailPhotoView.htm");
	else if( $dispmode == "detail" )
		return $smarty->fetch("../templates/DetailPhotoView.htm");	
}
//=======================================================================
//!	日付をクリッピングする
//!	@retval			---
//-----------------------------------------------------------------------
private function ClipDate
		(
		$yearcount , 
		$itemnum , 
		&$year , 
		&$month , 
		&$page
		)
{
	// year
	if( $year == false )
		return;
	if( false == $yearcount[ $year ] )
	{
		$keys = array_keys( $yearcount );
		if( count( $keys ) != 0 )
		{
			$year = $keys[ 0 ];
			$month	= false;
			$page	= 0;
		}
		else
		{
			$year = false;		
			$month	= false;
			$page	= 0;
		}
		return;
	}
	
	// month
	if( $month == false )
	{
		$pagenum	= ceil( $yearcount[ $year ]->Count / $itemnum );
		if( $page >= $pagenum )
			$page = $pagenum - 1;
		return;
	}
	if( false == $yearcount[ $year ]->MonthCountList[ $month ] )
	{
		$keys = array_keys( $yearcount[ $year ]->MonthCountList );
		if( count( $keys ) != 0 )
		{
			$month	= $keys[ 0 ];
			$page	= 0;
		}
		else
		{
			$month	= false;
			$page	= 0;
		}
		return;
	}
	
	// page
	$pagenum	= $yearcount[ $year ]->MonthCountList[ $month ];
	if( $page >= $pagenum )
		$page = $pagenum - 1;
	return;
}
//=======================================================================
//!	Show
//!	@retval			---
//-----------------------------------------------------------------------
private function PhotoView
		(
		$year , 
		$month , 
		$dispmode , 
		$page
		)
{
	if( $dispmode == "index" )
	{
		$w_num	= 10;
		$h_num	= 10;
	}
	else if( $dispmode == "thumbnail" )
	{
		$w_num	= 5;
		$h_num	= 5;
	}
	else if( $dispmode == "detail" )
	{
		$w_num	= 1;
		$h_num	= 10;
	}
	$p_num	= $w_num * $h_num;
	
	//表示位置のクリッピング
	$yearcount = $this->GetYearCount();
	$this->ClipDate( $yearcount , $p_num , $year , $month , $page );
	
	// sessionに格納
	$_SESSION[ "year" ]		= $year;
	$_SESSION[ "month" ] 	= $month;
	$_SESSION[ "dispmode" ]	= $dispmode;
	$_SESSION[ "page" ]		= $page;
	
	//初期化
	$smarty = new Smarty();

	//パラメータの設定
	$smarty->assign( "yearcount" , $yearcount );
	$smarty->assign( "photo_view" , $this->GetPhotoView( $year , $month , $dispmode , $page , $w_num , $h_num ) );
	$smarty->assign( "year" , $year );
	$smarty->assign( "month" , $month );
	$smarty->assign( "dispmode" , $dispmode );
	$smarty->assign( "page" , $page );
	$smarty->display( "../templates/PhotoView.htm" );
}
//=======================================================================
//!	Start
//!	@retval			---
//-----------------------------------------------------------------------
private function Start()
{
	// 最初の年の獲得
	$yearcount 	= $this->GetYearCount();
	$keys		= array_keys( $yearcount );
	$year;
	if( count( $keys ) != 0 )
		$year = $keys[ 0 ];

	// PhotoViewの表示
	$this->PhotoView( $year , false , "thumbnail" , 0 );
}
//=======================================================================
//!	New Photo
//!	@retval			---
//-----------------------------------------------------------------------
private function NewPhoto()
{
	global $g_FilesizeMax;

	//初期化
	$smarty = new Smarty();
	$smarty->assign( "max_file_size" , $g_FilesizeMax );
	$smarty->display( "../templates/NewPhoto.htm" );
}
//=======================================================================
//!	日付フォーマットのチェック
//!	@retval			---
//-----------------------------------------------------------------------
private function CheckDateFormat
		(
		$date_format , 
		&$date
		)
{
	$f_date;
	if( false == ereg( "^([0-9]{1,4})/([0-9]{1,2})/([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})$", $date_format, $f_date ) )
		return false;
	if( count( $f_date ) != 7 )
		return false;
	
	for( $off = 1 ; $off < 7 ; $off++ )
	{
		if( false == is_numeric($f_date[ $off ]) )
			return false;
	}
	$date = sprintf( "%04d%02d%02d%02d%02d%02d", $f_date[ 1 ] , $f_date[ 2 ] , $f_date[ 3 ] , $f_date[ 4 ] , $f_date[ 5 ] , $f_date[ 6 ] );
	return true;
}
//=======================================================================
//!	位置情報フォーマットのチェック
//!	@retval			---
//-----------------------------------------------------------------------
private function CheckLocationFormat
		(
		$location_format
		)
{
	$f_location;
	if( false == ereg( "^([NS]{1})([0-9]+)/([0-9]+):([0-9]+)/([0-9]+):([0-9]+)/([0-9]+) ([EW]{1})([0-9]+)/([0-9]+):([0-9]+)/([0-9]+):([0-9]+)/([0-9]+)$", $location_format, $f_location ) )
		return false;
	if( count( $f_location ) != 15 )
		return false;
	return true;
}
//=======================================================================
//!	エラー
//!	@retval			---
//-----------------------------------------------------------------------
private function Error
		(
		$message
		)
{
	//初期化
	$smarty = new Smarty();
	$smarty->assign( "message" , $message );
	$smarty->display( "../templates/Error.htm" );
}
//=======================================================================
//!	JumpPhotoView
//!	@retval			---
//-----------------------------------------------------------------------
private function JumpPhotoView()
{
	//初期化
	$smarty = new Smarty();
	if( $_SESSION[ "year" ] == true )
	{
		$smarty->assign( "command" , "photoview" );
		$smarty->assign( "year" , $_SESSION[ "year" ] );
		$smarty->assign( "month" , $_SESSION[ "month" ] );
		$smarty->assign( "dispmode" , $_SESSION[ "dispmode" ] );
		$smarty->assign( "page" , $_SESSION[ "page" ] );
		$smarty->display( "../templates/JumpPhotoView.htm" );
	}
	else
	{
		$smarty->display( "../templates/JumpPhotoView.htm" );
	}
}
//=======================================================================
//!	NewPhotoConfirm
//!	@retval			---
//-----------------------------------------------------------------------
private function NewPhotoConfirm
		(
		$filepath , 
		$title , 
		$comment , 
		$date , 
		$location
		)
{
	// dateのチェック
	if( $date != false && count( $date ) != 0 )
	{
		if( false == $this->CheckDateFormat( $date , $date ) )
		{
			$this->Error( "撮影日時の入力書式が違います。" );
			return;
		}
	}
	// locationのチェック
	if( $location != false && count( $location ) != 0 )
	{
		if( false == $this->CheckLocationFormat( $location ) )
		{
			$this->Error( "位置情報の入力書式が違います。" );
			return;
		}
	}

	// photoを新規作成
	$error = $this->CreatePhotoInfo( $filepath , $title , $comment , $date , $location );
	if( $error == true )
	{
		$this->Error( $error );
		return;
	}
	// PhotoViewにジャンプ
	$this->JumpPhotoView();
}
//=======================================================================
//!	upload
//!	@retval			---
//-----------------------------------------------------------------------
private function CreatePhotoInfo
		(
		$srcfile , 
		$title , 
		$comment , 
		$date , 
		$location
		)
{
	// JpegExifを読み込む
	$jpegexif	= new JpegExifReader();	
	if( false == $jpegexif->Load( $srcfile ) )
		return "JPEGファイルを読み込めません";

	//ロケーションの獲得
	if( $location == false )
	{
		$n = $jpegexif->GetGPSLatitude( $n0 , $n1 , $n2 , $n3 );
		$e = $jpegexif->GetGPSLongitude( $e0 , $e1 , $e2 , $e3 );
		if( $n == true && $e == true )
		{
			$location = $n0 . "" . $n1 . ":" . $n2 . ":" . $n3 . " " . $e0 . "" . $e1 . ":" . $e2 . ":" . $e3;
		}
	}
	//日付の獲得
	if( $date == false )
	{
		$date = $jpegexif->GetDateTimeOriginal();
		if( $date == true )
		{
			//2007:08:24 20:02:42
			$date = str_replace( ":" , "" , $date );
			$date = str_replace( " " , "" , $date );
		}
	}
	if( $date == false )
	{
		$date = date( "YmdHis" );
	}

	// IDの生成
	$id = GenerateFilename( $img_folder , "jpg" );

	//ファイルの生成
	$img_path = $this->m_ImgFolder . "/" . $id . ".jpg";
	if ( FALSE == move_uploaded_file( $srcfile , $img_path ) ) 
		return "画像ファイルを作成できません";

	// サムネイルの生成
	if( false == GenerateJPEGThumbnail( $img_path , $this->m_Thumb0_Folder . "/" . $id . ".jpg" , 200 , 200 ) )
		return "サムネイル画像を作成できません";
	if( false == GenerateJPEGThumbnail( $img_path , $this->m_Thumb1_Folder . "/" . $id . ".jpg" , 100 , 100 ) )
		return "サムネイル画像を作成できません";

	// データベースの作成
	$this->m_DB->Open();
	if( false == $this->m_DB->Insert( $id , $title , $comment , $location , $date ) )
	{
		$this->m_DB->Close();
		return "データベースのアイテムを作成できません";
	}
	$this->m_DB->Close();
}
//=======================================================================
//!	日付フォーマットの獲得
//!	@retval			---
//-----------------------------------------------------------------------
private function DateFormat
		(
		$date
		)
{
	$f_date = sprintf
			( 
			"%04d/%02d/%02d %02d:%02d:%02d", 
			substr( $date , 0 , 4 ) , 
			substr( $date , 4 , 2 ) , 
			substr( $date , 6 , 2 ) , 
			substr( $date , 8 , 2 ) , 
			substr( $date , 10 , 2 ) , 
			substr( $date , 12 , 2 )
			);
	return $f_date;
}
//=======================================================================
//!	EditPhoto
//!	@retval			---
//-----------------------------------------------------------------------
private function EditPhoto
		(
		$id
		)
{
	$this->m_DB->Open();
	$data = $this->m_DB->GetData( $id );
	$this->m_DB->Close();

	// データのチェック	
	if( $data == false )
	{
		$this->Error( "画像が見つかりません" );
		return;
	}

	//編集画面の作成
	$smarty = new Smarty();
	$smarty->assign( "id" , $id );
	$smarty->assign( "title" , $data[ 0 ][ "title" ] );
	$smarty->assign( "imagepath" , $this->m_Thumb0_Folder . "/" . $id . ".jpg" );
	$smarty->assign( "comment" , $data[ 0 ][ "comment" ] );
	$smarty->assign( "date" , $this->DateFormat( $data[ 0 ][ "date" ] ) );
	$smarty->assign( "location" , $data[ 0 ][ "location" ] );
	$smarty->display( "../templates/EditPhoto.htm" );
}
//=======================================================================
//!	EditPhotoConfirm
//!	@retval			---
//-----------------------------------------------------------------------
private function EditPhotoConfirm
		(
		$id , 
		$title , 
		$comment , 
		$date , 
		$location
		)
{
	// dateのチェック
	if( $date != false && count( $date ) != 0 )
	{
		if( false == $this->CheckDateFormat( $date , $date ) )
		{
			$this->Error( "撮影日時の入力書式が違います。" );
			return;
		}
	}
	// locationのチェック
	if( $location != false && count( $location ) != 0 )
	{
		if( false == $this->CheckLocationFormat( $location ) )
		{
			$this->Error( "位置情報の入力書式が違います。" );
			return;
		}
	}

	// データベースの書き換え
	$this->m_DB->Open();
	if( false == $this->m_DB->ChangePhotoInfo( $id , $title , $comment , $location , $date ) )
	{
		$this->Error( "指定された写真が見つかりません" );
		return;
	}
	$this->m_DB->Close();

	// PhotoViewにジャンプ
	$this->JumpPhotoView();
}
//=======================================================================
//!	DeletePhotoConfirm
//!	@retval			---
//-----------------------------------------------------------------------
private function DeletePhotoConfirm
		(
		$id
		)
{
	$this->m_DB->Open();
	$data = $this->m_DB->GetData( $id );
	$this->m_DB->Close();

	// データのチェック	
	if( $data == false )
	{
		$this->Error( "画像が見つかりません" );
		return;
	}

	//編集画面の作成
	$smarty = new Smarty();
	$smarty->assign( "id" , $id );
	$smarty->assign( "title" , $data[ 0 ][ "title" ] );
	$smarty->assign( "imagepath" , $this->m_Thumb0_Folder . "/" . $id . ".jpg" );
	$smarty->assign( "comment" , $data[ 0 ][ "comment" ] );
	$smarty->assign( "commentdisp" , str_replace( "\r\n" , "<br>" , $data[ 0 ][ "comment" ] ) );
	$smarty->assign( "date" , $this->DateFormat( $data[ 0 ][ "date" ] ) );
	$smarty->assign( "location" , $data[ 0 ][ "location" ] );
	$smarty->display( "../templates/DeletePhotoConfirm.htm" );
}
//=======================================================================
//!	DeletePhotoConfirm
//!	@retval			---
//-----------------------------------------------------------------------
private function DeletePhoto
		(
		$id
		)
{
	// DBからアイテムを削除する
	$this->m_DB->Open();
	$ret = $this->m_DB->DeletePhoto( $id );
	$this->m_DB->Close();
	
	if( $ret == false )
	{
		$this->Error( "画像が見つかりません" );
		return;
	}
	//実際の画像を削除する
	unlink( $this->m_ImgFolder . "/" . $id . ".jpg" );
	unlink( $this->m_Thumb0_Folder . "/" . $id . ".jpg" );
	unlink( $this->m_Thumb1_Folder . "/" . $id . ".jpg" );

	// PhotoViewにジャンプ
	$this->JumpPhotoView();
}
//=======================================================================
//!	location to array
//!	@retval			---
//-----------------------------------------------------------------------
private function LocationToArray
		(
		$location_format , 
		&$n , 
		&$e
		)
{
	$f_location;
	if( false == ereg( "^([NS]{1})([0-9]+)/([0-9]+):([0-9]+)/([0-9]+):([0-9]+)/([0-9]+) ([EW]{1})([0-9]+)/([0-9]+):([0-9]+)/([0-9]+):([0-9]+)/([0-9]+)$", $location_format, $f_location ) )
		return false;
	if( count( $f_location ) != 15 )
		return false;
	$n	= array();
	for( $off = 0 ;$off < 3 ; $off++ )
	{
		$n[ $off ] = $f_location[ 2 + $off * 2 ] / $f_location[ 2 + $off * 2 + 1 ];
	}
	$e	= array();
	for( $off = 0 ;$off < 3 ; $off++ )
	{
		$e[ $off ] = $f_location[ 9 + $off * 2 ] / $f_location[ 9 + $off * 2 + 1 ];
	}
	
	return true;
}
//=======================================================================
//!	PhotoInfo
//!	@retval			---
//-----------------------------------------------------------------------
private function PhotoInfo
		(
		$id
		)
{
	$this->m_DB->Open();
	$data = $this->m_DB->GetData( $id );
	$this->m_DB->Close();
	if( $data == false )
	{
		$this->Error( "画像が見つかりません" );
		return;
	}
	// PhotoInfoを作成
	$smarty = new Smarty();
	$smarty->assign( "id" , $id );
	$smarty->assign( "title" , $data[ 0 ][ "title" ] );
	$smarty->assign( "imagepath" , $this->m_ImgFolder . "/" . $id . ".jpg" );
	$smarty->assign( "comment" , $data[ 0 ][ "comment" ] );
	$smarty->assign( "commentdisp" , str_replace( "\r\n" , "<br>" , $data[ 0 ][ "comment" ] ) );
	$smarty->assign( "date" , $this->DateFormat( $data[ 0 ][ "date" ] ) );
	$smarty->assign( "location" , $data[ 0 ][ "location" ] );

	$n;
	$e;
	$this->LocationToArray( $data[ 0 ][ "location" ] , $n , $e );
	$smarty->assign( "n" , $n );
	$smarty->assign( "e" , $e );
	$smarty->display( "../templates/PhotoInfo.htm" );
}
//=======================================================================
//!	PasseordCheck
//!	@retval			---
//-----------------------------------------------------------------------
private function Login()
{
	global $g_MasterUserId , $g_MasterPasseord;

	// Masterが設定していない場合は素通り
	if( $g_MasterUserId == false )
		return true;

	// すでにログイン済み
	if( ( $_SESSION[ "userid" ] == true  )
	 && ( $_SESSION[ "password" ] == true )
	 && ( $_SESSION[ "userid" ] == $g_MasterUserId )
	 && ( $_SESSION[ "password" ] == $g_MasterPasseord ) )
	 	return true;

	$smarty = new Smarty();
	$smarty->display( "../templates/Login.htm" );
	
	return false;
}
//=======================================================================
//!	Login confirm
//!	@retval			---
//-----------------------------------------------------------------------
private function LoginConfirm
		(
		$userid , 
		$password
		)
{
	global $g_MasterUserId , $g_MasterPasseord;

	
	//パスワードのチェック
	if( ( $userid == $g_MasterUserId )
	&&  ( $password == $g_MasterPasseord ) )
	{
		$_SESSION[ "userid" ]	= $userid;
		$_SESSION[ "password" ]	= $password;
		$this->JumpPhotoView();
		return;
	}
	$this->Error( "ユーザIDまたはパスワードが違います" );
}
// public functions
//=======================================================================
//!	construct
//-----------------------------------------------------------------------
function __construct
		(
		$img_folder , 
		$thumb0_folder , 
		$thumb1_folder , 
		$db_path ,
		$upload_name
		)
{
	$this->m_ImgFolder		= $img_folder;
	$this->m_Thumb0_Folder	= $thumb0_folder;
	$this->m_Thumb1_Folder	= $thumb1_folder;
	$this->m_DB_Path		= $db_path;
	$this->m_Upload_Name	= $upload_name;
	
	// directoryの生成
	CreateFolderFull( $this->m_ImgFolder );
	CreateFolderFull( $this->m_Thumb0_Folder );
	CreateFolderFull( $this->m_Thumb1_Folder );
	CreateFolderFull( GetDirectory( $this->m_DB_Path ) );

	$this->m_DB		= new WebPhotoDB( $this->m_DB_Path );
}
//=======================================================================
//!	destruct
//-----------------------------------------------------------------------
function __destruct()
{
}
//=======================================================================
//!	Update
//!	@retval			---
//-----------------------------------------------------------------------
public function Update()
{
	session_start();

	// ログインチェック
	$command = $_GET[ "command" ];
	if( $command == "loginconfirm" )
	{
		$this->LoginConfirm( $_POST[ "userid" ] , $_POST[ "password" ] );
		return;
	}
	
	// ログインチェック
	if( false == $this->Login()	)
		return;

	// コマンド分岐	
	if( $command == false )
	{
		$this->Start();
	}
	else if( $command == "photoview" )
	{
		$this->PhotoView
				(
				$_GET[ "year" ] , 
				$_GET[ "month" ] , 
				$_GET[ "dispmode" ] , 
				$_GET[ "page" ]
				);
	}
	else if( $command == "newphoto" )
	{
		$this->NewPhoto();
	}
	else if( $command == "newphotoconfirm" )
	{
		// ファイルサイズのチェック
		global $g_FilesizeMax;
		if( $_FILES[ 'userfile']['size'] > $g_FilesizeMax )
		{
			$this->Error( "画像ファイルのサイズが大きすぎます" );
			return;
		}
		$this->NewPhotoConfirm( $_FILES[ 'userfile']['tmp_name'] , $_POST[ "title" ] , $_POST[ "comment" ] , $_POST[ "date" ] , $_POST[ "location" ] );
	}
	else if( $command == "editphoto" )
	{
		$this->EditPhoto
				(
				$_GET[ "id" ]
				);
	}
	else if( $command == "editphotoconfirm" )
	{
		if( $_POST[ "change" ] == true )
			$this->EditPhotoConfirm( $_GET[ 'id' ] , $_POST[ "title" ] , $_POST[ "comment" ] , $_POST[ "date" ] , $_POST[ "location" ] );
		else 
			$this->DeletePhotoConfirm( $_GET[ 'id' ] );
	}
	else if( $command == "deletephoto" )
	{
		$this->DeletePhoto( $_GET[ 'id' ] );
	}
	else if( $command == "photoinfo" )
	{	
		$this->PhotoInfo( $_GET[ 'id' ] );
	}
	else
	{
		$this->Error( "ページが見つかりません" );
	}
}
//=======================================================================
//!	upload
//!	@retval			---
//-----------------------------------------------------------------------
public function Upload()
{
	// パスワードのチェック
	global $g_MasterUserId , $g_MasterPasseord , $g_FilesizeMax;
	if( $g_MasterUserId == true )
	{
		if( $g_MasterUserId != $_POST[ "userid" ] )
		{
			print "invalid userid";
			return;
		}
		if( $g_MasterPasseord != $_POST[ "password" ] )
		{
			print "invalid password";
			return;
		}
	}
	// ファイルサイズのチェック
	if( $_FILES[ $this->m_Upload_Name ]['size'] > $g_FilesizeMax )
	{
		print "file is too large.";
		return;
	}
	
	// photo infoの作成
	$error = $this->CreatePhotoInfo( $_FILES[ $this->m_Upload_Name ]['tmp_name'] , "" , "" , false , false );
	if( true == $error )
	{
		print $error;
		return;
	}
	print "success:";
}


};

?>