<?php
require_once( './ClassPHP/SQLite.class.php' );


/****************************************************************************
"WebPhotoDB" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
class WebPhotoDB
{
// member variable
private		$m_DB;
private		$m_Tablename;

// public functions
//=======================================================================
//!	construct
//-----------------------------------------------------------------------
function __construct
		(
		$path
		)
{
	$this->m_Tablename = "webphoto";
	$this->m_DB = new SQLite( $path );
	$this->m_DB->Open();
	
	// table̍쐬
	$this->m_DB->Query( "CREATE TABLE " . $this->m_Tablename . " (id TEXT, title TEXT, comment TEXT, location TEXT, date TIMESTAMP )" );
	
	$this->m_DB->Close();
}
//=======================================================================
//!	destruct
//-----------------------------------------------------------------------
function __destruct()
{
	$this->m_DB->Close();
}
//=======================================================================
//! J	
//!	@retval			---
//-----------------------------------------------------------------------
public function Open()
{
	$this->m_DB->Open();
}
//=======================================================================
//! 	
//!	@retval			---
//-----------------------------------------------------------------------
public function Close()
{
	$this->m_DB->Close();
}
//=======================================================================
//!	ID݂邩ׂ
//!	@retval			---
//-----------------------------------------------------------------------
public function IsIdExist
		(
		$id
		)
{
	$code	= "SELECT id FROM " . $this->m_Tablename . " WHERE id=\"" . $id . "\"";
	$result = $this->m_DB->ArrayQuery( $code );
	
	if( 0 == count( $result ) )
		return false;
	return true;
}
//=======================================================================
//!	ACe̕ύX
//!	@retval			---
//-----------------------------------------------------------------------
public function ChangePhotoInfo
		(
		$id , 
		$title , 
		$comment , 
		$location , 
		$date
		)
{
	$code = "UPDATE " . $this->m_Tablename . " SET ";
	
	$code .= "title=\"" . $title . "\"";
	$code .= ",comment=\"" . $comment . "\"";
	if( location == true )
		$code .= ",location=\"" . $location . "\"";
	if( date == true )
		$code .= ",date=\"" . $date . "\"";
	$code .= " WHERE id=\"" . $id . "\"";
	
	return $this->m_DB->Query( $code );
}
//=======================================================================
//! ACe̒ǉ	
//!	@retval			---
//-----------------------------------------------------------------------
public function Insert
		(
		$id , 
		$title , 
		$comment , 
		$location , 
		$date
		)
{
	if( true == $this->IsIdExist( $id ) )
		return false;

	$before = false;
	$code = "INSERT INTO " . $this->m_Tablename;
	$code .= " (";
	if( $id == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "id";
	}
	if( $title == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "title";
	}
	if( $comment == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "comment";
	}
	if( $location == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "location";
	}
	if( $date == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "date";
	}
	$code .= ") VALUES (";
	$before = false;
	if( $id == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "\"" . $id . "\"";
	}
	if( $title == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "\"" . $title . "\"";
	}
	if( $comment == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "\"" . $comment . "\"";
	}
	if( $location == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "\"" . $location . "\"";
	}
	if( $date == true )
	{
		if( $before == true )
			$code .= ",";
		$before = true;
		$code .= "\"" . $date . "\"";
	}
	$code .= ")";
	return $this->m_DB->Query( $code );
}
//=======================================================================
//!	tXg̊l
//!	@retval			---
//-----------------------------------------------------------------------
public function GetDatelist()
{
	$code	= "SELECT date FROM " . $this->m_Tablename . " ORDER BY date";
	return $this->m_DB->ArrayQuery( $code );
}
//=======================================================================
//! ÑXg̊l	
//!	@retval			---
//-----------------------------------------------------------------------
public function GetDatelistInYear
		(
		$year
		)
{
	$code	= "SELECT date FROM " . $this->m_Tablename . " WHERE date >= " . $year . "0000000000" . " AND date <= " . $year . "9999999999" . " ORDER BY date";
	return $this->m_DB->ArrayQuery( $code );
}
//=======================================================================
//!	IDXg̊l
//!	@retval			---
//-----------------------------------------------------------------------
public function GetIDList
		(
		$start_date , 
		$end_date
		)
{
	$code	= "SELECT id FROM " . $this->m_Tablename . " WHERE date >= " . $start_date . " AND date <= " . $end_date . " ORDER BY date";
	return $this->m_DB->ArrayQuery( $code );

}
//=======================================================================
//!	f[^̊l
//!	@retval			---
//-----------------------------------------------------------------------
public function GetData
		(
		$id
		)
{
	$code	= "SELECT title,comment,location,date FROM " . $this->m_Tablename . " WHERE id=\"" . $id . "\" ORDER BY date";
	return $this->m_DB->ArrayQuery( $code );
}
//=======================================================================
//!	ʐ^̍폜
//!	@retval			---
//-----------------------------------------------------------------------
public function DeletePhoto
		(
		$id
		)
{
	$code	= "DELETE FROM " . $this->m_Tablename . " WHERE id=\"" . $id . "\"";
	return $this->m_DB->Query( $code );
}
};

?>